diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
index 69e9a846d..26dd801ef 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
@@ -8,6 +8,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLeavesCacao;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -23,21 +25,21 @@ public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeave
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        super.render(tessellator, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        super.render(tessellator, worldSource, x, y, z);
 
         AABB bounds = block.getBounds();
 
-        final int growthRate = BlockLogicLeavesCacao.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
+        final int growthRate = BlockLogicLeavesCacao.getGrowthRate(worldSource.getBlockMetadata(x, y, z));
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-            int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
+            int lmc = block.getLightmapCoord(worldSource, x, y, z);
             if(block.emission > 0) {
                 lmc = LightmapHelper.setBlocklightValue(lmc, 15);
             }
             tessellator.setLightmapCoord(lmc);
         }else {
-            brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
             if(block.emission > 0) {
                 brightness = 1.0f;
             }
@@ -48,19 +50,19 @@ public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeave
         if (growthRate > 0) {
             renderBlocks.overrideBlockTexture = growthStages[Math.min(growthRate - 1, BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1)];
             tessellator.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
-            renderNorthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
-            renderSouthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
+            renderBlocks.renderNorthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
+            renderBlocks.renderSouthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
             tessellator.setColorOpaque_F(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
-            renderEastFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
-            renderWestFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
+            renderBlocks.renderEastFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
+            renderBlocks.renderWestFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
             renderBlocks.overrideBlockTexture = null;
         }
 
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         AABB bounds = block.getBounds();
@@ -70,32 +72,32 @@ public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeave
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
index fbd3b8034..b832795d9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
@@ -7,6 +7,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLeavesCherryFlowering;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -18,24 +20,24 @@ public class BlockModelLeavesCherryFlowering<T extends BlockLogic> extends Block
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        super.render(tessellator, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        super.render(tessellator, worldSource, x, y, z);
 
-        int growthRate = BlockLogicLeavesCherryFlowering.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
+        int growthRate = BlockLogicLeavesCherryFlowering.getGrowthRate(worldSource.getBlockMetadata(x, y, z));
         if(growthRate > 0) {
             renderBlocks.overrideBlockTexture = grownCherryOverlay;
         } else {
             renderBlocks.overrideBlockTexture = floweringCherryOverlay;
         }
 
-        renderStandardBlock(tessellator, block.getBoundsRaw(), x, y, z, 1.0f, 1.0f, 1.0f);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBoundsRaw(), x, y, z, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = null;
 
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         AABB bounds = block.getBoundsRaw();
@@ -45,32 +47,32 @@ public class BlockModelLeavesCherryFlowering<T extends BlockLogic> extends Block
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index 4d8f54e4f..451b907a5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -3,14 +3,17 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLever;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelLever(Block<T> block) {
@@ -18,14 +21,14 @@ public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int l = worldSource.getBlockMetadata(x, y, z);
         int i1 = l & 15;
         boolean flag = (l & 16) > 0;
         boolean flag1 = renderBlocks.overrideBlockTexture != null;
         if(!flag1)
         {
-            renderBlocks.overrideBlockTexture = BlockModelDispatcher.getInstance().getDispatch(Blocks.COBBLE_STONE).getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
+            renderBlocks.overrideBlockTexture = TextureRegistry.getTexture("minecraft:block/cobbled_stone");
         }
         float f = 0.25F;
         float f1 = 0.1875F;
@@ -57,19 +60,19 @@ public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T>
                 bounds.set(0.0F, 0.5F - f, 0.5F - f1, f2, 0.5F + f, 0.5F + f1);
                 break;
         }
-        renderStandardBlock(tessellator, bounds, x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         if(!flag1)
         {
             renderBlocks.overrideBlockTexture = null;
         }
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
         }else {
 			if(block.emission > 0) {
 				brightness = 1.0f;
 			}else {
-				brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+				brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
 			}
         }
         
@@ -218,8 +221,5 @@ public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T>
     public boolean shouldItemRender3d() {
         return false;
     }
-    @Override
-    public float getItemRenderScale() {
-        return 0.5f;
-    }
+
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
index ab891b458..f65c25dd4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
@@ -6,6 +6,8 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -17,18 +19,18 @@ public class BlockModelOverlayLeaves<T extends BlockLogic> extends BlockModelLea
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        super.render(tessellator, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        super.render(tessellator, worldSource, x, y, z);
 
         renderBlocks.overrideBlockTexture = overlayTexture;
-        renderStandardBlock(tessellator, block.getBoundsRaw(), x, y, z, 1.0f, 1.0f, 1.0f);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBoundsRaw(), x, y, z, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = null;
 
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         AABB bounds = block.getBounds();
@@ -38,32 +40,32 @@ public class BlockModelOverlayLeaves<T extends BlockLogic> extends BlockModelLea
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
index 1181804e2..62b54ba2a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
@@ -8,6 +8,9 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPebbles<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate[] pebbles = {
@@ -20,18 +23,18 @@ public class BlockModelPebbles<T extends BlockLogic> extends BlockModelStandard<
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(LightmapHelper.max(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z), block.getLightmapCoord(renderBlocks.blockAccess, x, y - 1, z)));
+        	tessellator.setLightmapCoord(LightmapHelper.max(block.getLightmapCoord(worldSource, x, y, z), block.getLightmapCoord(worldSource, x, y - 1, z)));
         }else {
-        	brightness = Math.max(getBlockBrightness(renderBlocks.blockAccess, x, y, z), getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z));
+        	brightness = Math.max(renderBlocks.getBlockBrightness(worldSource, x, y, z), renderBlocks.getBlockBrightness(worldSource, x, y - 1, z));
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
-        renderTopFace(tessellator,
-            block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z),
+        renderBlocks.renderTopFace(tessellator,
+            block.getBlockBoundsFromState(worldSource, x, y, z),
             x, y, z,
-            getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.blockAccess.getBlockMetadata(x, y, z)));
+            getBlockTextureFromSideAndMetadata(Side.TOP, worldSource.getBlockMetadata(x, y, z)));
 
         return true;
     }
@@ -40,7 +43,7 @@ public class BlockModelPebbles<T extends BlockLogic> extends BlockModelStandard<
         return false;
     }
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         return pebbles[MathHelper.clamp(data, 0, 2)];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
index 88fa02e4c..9a241f8f9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
@@ -7,6 +7,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicEdible;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModelStandard<T> {
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/side");
@@ -20,15 +22,15 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
         withCustomItemBounds(f, 0.0F, f, 1.0F - f, f1, 1.0F - f);
     }
 
-    public void renderSliceSide(Tessellator tessellator, AABB bounds, int x, int y, int z, Side side, boolean overrideTex) {
+    public void renderSliceSide(Tessellator tessellator, WorldSource worldSource, AABB bounds, int x, int y, int z, Side side, boolean overrideTex) {
         if(overrideTex)
             renderBlocks.overrideBlockTexture = insideTexture;
-        renderSide(tessellator, bounds, x, y, z, side, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 0, 0, 0, side, 0);
         if(overrideTex)
             renderBlocks.overrideBlockTexture = null;
     }
 
-    private void renderSlice(Tessellator tessellator, AABB bounds, int x, int y, int z, int sliceX, int sliceZ) {
+    private void renderSlice(Tessellator tessellator, WorldSource worldSource, AABB bounds, int x, int y, int z, int sliceX, int sliceZ) {
 
         double onePix = 0.0625;
         double sliceWidth = onePix * 8;
@@ -50,30 +52,30 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
 
         maxSlices = block.getLogic().maxBites;
         bounds.set(xMin + offsetXMin, 0.0F, zMin + offsetZMin, xMax - offsetXMax, 0.375F, zMax - offsetZMax);
-        renderSide(tessellator, bounds, x, y, z, Side.TOP, 0);
-        renderSide(tessellator, bounds, x, y, z, Side.BOTTOM, 0);
-        renderSliceSide(tessellator, bounds, x, y, z, Side.SOUTH, insideSouth);
-        renderSliceSide(tessellator, bounds, x, y, z, Side.WEST, insideWest);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.TOP, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.BOTTOM, 0);
+        renderSliceSide(tessellator, worldSource, bounds, x, y, z, Side.SOUTH, insideSouth);
+        renderSliceSide(tessellator, worldSource, bounds, x, y, z, Side.WEST, insideWest);
         renderBlocks.flipTexture = true;
-        renderSliceSide(tessellator, bounds, x, y, z, Side.NORTH, insideNorth);
-        renderSliceSide(tessellator, bounds, x, y, z, Side.EAST, insideEast);
+        renderSliceSide(tessellator, worldSource, bounds, x, y, z, Side.NORTH, insideNorth);
+        renderSliceSide(tessellator, worldSource, bounds, x, y, z, Side.EAST, insideEast);
         renderBlocks.flipTexture = false;
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
 
-        final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        final int meta = worldSource.getBlockMetadata(x, y, z);
         renderBlocks.enableAO = true;
-        renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
+        renderBlocks.cache.setupCache(block, worldSource, x, y, z);
         int slices = 0;
         for(int xSlice = 0; xSlice < 2; xSlice++){
             for(int zSlice = 0; zSlice < 2; zSlice++) {
                 slices++;
                 if(meta >= slices)
                     continue;
-                renderSlice(tessellator, bounds, x, y, z, xSlice, zSlice);
+                renderSlice(tessellator, worldSource, bounds, x, y, z, xSlice, zSlice);
             }
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index a81cd0632..a448df03a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -8,6 +8,8 @@ import net.minecraft.core.block.piston.BlockLogicPistonBase;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModelStandard<T> {
@@ -39,21 +41,21 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z){
-        return renderPistonBase(tessellator, x, y, z, false);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z){
+        return renderPistonBase(tessellator, worldSource, x, y, z, false);
     }
 
     private boolean headless = false;
-    public boolean renderHeadless(Tessellator tessellator, int x, int y, int z) {
+    public boolean renderHeadless(Tessellator tessellator, WorldSource worldSource, int x, int y, int z) {
         renderBlocks.renderAllFaces = true;
         headless = true;
-        boolean result = renderPistonBase(tessellator, x, y, z, true);
+        boolean result = renderPistonBase(tessellator, worldSource, x, y, z, true);
         headless = false;
         renderBlocks.renderAllFaces = false;
         return result;
     }
-    protected boolean renderPistonBase(Tessellator tessellator, int x, int y, int z, boolean noCulling) {
-        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    protected boolean renderPistonBase(Tessellator tessellator, WorldSource worldSource, int x, int y, int z, boolean noCulling) {
+        int meta = worldSource.getBlockMetadata(x, y, z);
         boolean extended = noCulling || (meta & 8) != 0;
         Direction direction = BlockLogicPistonBase.getDirection(meta);
         AABB bounds;
@@ -106,8 +108,8 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                 default:
                     bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
             }
-            renderStandardBlock(tessellator, bounds, x, y, z);
-            resetRenderBlocks();
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+            renderBlocks.resetRenderBlocks();
         } else
         {
             switch(direction)
@@ -145,14 +147,14 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateBottom = 2;
                     break;
             }
-            renderStandardBlock(tessellator, block.getBounds(), x, y, z);
-            resetRenderBlocks();
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBounds(), x, y, z);
+            renderBlocks.resetRenderBlocks();
         }
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderBlockOnInventory(tessellator, 1, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderStandalone(tessellator, 1, brightness, alpha, lightmapCoordinate);
     }
     public IconCoordinate getFaceTexture()
     {
@@ -160,7 +162,7 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         Direction direction = BlockLogicPistonBase.getDirection(data);
         if (direction == Direction.NONE)
